
{$APPTYPE GUI}{$MODE DELPHI}

program demo42;

uses
  SysUtils,windows,math,gl,glu,glext,GraphOGL,GOGL_Collision;

//const
 
//type
  
var 
  i,l:integer;
  timer:array[1..10]of integer;
  camera:array[0..3]of gluint;
  SelTexRis:integer = 2; 
  TexRis:integer;
  luce:TGLVector;
  MouviLuce:boolean = true;
  TexMat:boolean = true;
  SetMat:integer = 0;
   
//{$R *.rc}
//{$R *.res}  


procedure Quad(x1,y1,z1,x2,y2,z2,x3,y3,z3,x4,y4,z4,tu,tv:glFloat);
begin
  TwoSideON;
  glDisable(GL_CULL_FACE);
  glBegin(GL_QUADS);
   FindNormal(x2,y2,z2,x1,y1,z1,x3,y3,z3);
   glNormal3f(FNormal[1], FNormal[2], FNormal[3]);
	LineFree(1*tu,-1*tv, 0,-1*tv, x2,y2,z2, x1,y1,z1,true);
	LineFree(0,0, 1*tu,0, x3,y3,z3, x4,y4,z4,true);	
  glEnd;
  glEnable(GL_CULL_FACE);
  TwoSideOFF;  
end; 


procedure Ripresa;
begin
  glClearColor(0,0,0,0);
  glClear(GL_COLOR_BUFFER_BIT or GL_DEPTH_BUFFER_BIT);

  glTranslatef(0,0,-10);   
  glRotatef(0,1,0,0); 
  
  if not MouviLuce then PutglPointLight(GL_LIGHT0,0, luce.x,luce.y,luce.z, 0); 
  
  glRotatef(xRot,1,0,0);
  glRotatef(yRot,0,1,0);   
  
  if MouviLuce then PutglPointLight(GL_LIGHT0,0, luce.x,luce.y,luce.z, 0);  	  
		
  TextureOFF;
 
  //SetglNewMat(192/300,192/300,192/300, 0.25,0.25,0.25, 192/300,192/300,192/300, 0.1,0.1,0.1, 50);
  PutMaterial(SetMat);  
  glPushMatrix;    
  glRotatef(90,-1,0,0); 
  Sfera(0,0,0, 3.85,TexRis,TexRis, 1); 
  glPopMatrix;  
	
  TextureON;  
end;


procedure Scena;
begin
  glPushMatrix;  
  glRotatef(90,-1,0,0); 
  PutglTeapot(0,0,0, 1.5,32);
  glPopMatrix;  
end;


procedure Ev1;
begin
  glTexEnvi(GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_MODULATE);

  glEnable(GL_TEXTURE_GEN_S);
  glEnable(GL_TEXTURE_GEN_T);
  glTexGeni(GL_S, GL_TEXTURE_GEN_MODE, GL_SPHERE_MAP);  
  glTexGeni(GL_T, GL_TEXTURE_GEN_MODE, GL_SPHERE_MAP);   
   
  BindTexCamera(camera[0]);
end;


procedure Ev2;
begin
  glDisable(GL_TEXTURE_GEN_S);
  glDisable(GL_TEXTURE_GEN_T); 

  TextureSelectID(0);
end;


procedure OpenGL_CreateList();

procedure OpenGL_Texture();
begin    
  
  TextureLoadID('pavement.bmp',0);
  
end;
begin 

  OpenGL_Texture();

  luce:=glvector(0,10,0);  
  
  // carica il materiale da file  
  LoadMaterial('vetro.mtl',0); 
  LoadMaterial('vetro2.mtl',1);
  LoadMaterial('blood.mtl',2);
  LoadMaterial('mela.mtl',3);
  
  SetTexCamera(512,512,GL_RGB,GL_RGB,camera[0]);  

end;


procedure OpenGL_Draw();

procedure OpenGL_Draw2D();
begin
 
  OpenGL_I2D(0,0,0,0);       // inizializza la grafica 2D 
  
  // schermo virtuale
  glDisable(GL_LIGHTING);  
  BindTexCamera(camera[0]);
  glPushMatrix;  
  glTranslatef(1,0,0);   
  Quad(-1,-1,0, 1,-1,0, -1,1,0, 1,1,0, 1,1); 
  glPopMatrix; 
  glEnable(GL_LIGHTING);    
  
  OpenGL_Init(100,0,0,0,0);  // reimposta la grafica 3D
  
end;
procedure OpenGL_Mouse2D();
begin
  
end;
procedure OpenGL_Keyboard();
begin
  
  if SetglKey('D')or SetglKey(VK_RIGHT)then
  begin
    timer[1]:=timer[1]+1;
    if timer[1]=3 then SelTexRis:=SelTexRis+1;
	if timer[1]>=10 then timer[1]:=0;
  end else timer[1]:=0;  
  if SelTexRis>5 then SelTexRis:=0;
  
  if SetglKey('A')or SetglKey(VK_LEFT)then
  begin
    timer[2]:=timer[2]+1;
    if timer[2]=3 then SelTexRis:=SelTexRis-1;
	if timer[2]>=10 then timer[2]:=0;
  end else timer[2]:=0;    
  if SelTexRis<0 then SelTexRis:=5;
  
  if SetglKey('L')then
  begin
    timer[3]:=timer[3]+1;
    if timer[3]=3 then MouviLuce:=not(MouviLuce);
	if timer[3]>=10 then timer[3]:=0;
  end else timer[3]:=0;    
  
  if SetglKey('M')then
  begin
    timer[4]:=timer[4]+1;
    if timer[4]=3 then TexMat:=not(TexMat);
	if timer[4]>=10 then timer[4]:=0;
  end else timer[4]:=0;       
  
  if SetglKey(VK_SPACE)then
  begin
    timer[5]:=timer[5]+1;
    if timer[5]=3 then SetMat:=SetMat+1;
	if timer[5]>=10 then timer[5]:=0;
  end else timer[5]:=0;  
  if SetMat>3 then SetMat:=0; 
  
end;
begin
  // creazione telecamera virtuale
  GenTexCamera(Ripresa,512,512,100,camera[0]);

  // reimposta il colore dello sfondo 
  glClearColor(0,0,0,0);  
  
  glClear(GL_COLOR_BUFFER_BIT OR GL_DEPTH_BUFFER_BIT);
  glLoadIdentity();
 
  OpenGL_Draw2D();               // carica gli elementi per la grafica 2d 
  OpenGL_Mouse2D();              // carica i comandi del mause per la grafica 2d
  OpenGL_Keyboard();             // carica i comandi della tastiera
  
  glTranslatef(-5.5,-2,-20);        // regola l'inquadratura degli elementi nello schermo
  glRotatef(20,1,0,0); 
  
  if not MouviLuce then 
  begin
    PutglPointLight(GL_LIGHT0,0, luce.x,luce.y,luce.z, 0);
    glDisable(GL_LIGHTING);
    TextureOFF;  	
	Sfera(luce.x,luce.y,luce.z, 0.25,10);
	TextureON;
    glEnable(GL_LIGHTING);  	
  end;  
  
  SetglMouseMove(GL_M0,2);    
  
  if MouviLuce then 
  begin
    PutglPointLight(GL_LIGHT0,0, luce.x,luce.y,luce.z, 0);
    glDisable(GL_LIGHTING);
    TextureOFF;  	
	Sfera(luce.x,luce.y,luce.z, 0.25,10);
	TextureON;
    glEnable(GL_LIGHTING);
  end;  
   
  if TexMat then FX_Mixer(Scena,Ev1,Ev2)else
  begin
  TextureSelectID(0); 
  PutMaterial(SetMat);  
  glPushMatrix;  
  glRotatef(90,-1,0,0); 
  PutglTeapot(0,0,0, 1.5,32);
  glPopMatrix;
  end;  
 
  case SelTexRis of
    0: TexRis:=10;
    1: TexRis:=16;
    2: TexRis:=32;
    3: TexRis:=64;	
    4: TexRis:=128;
    5: TexRis:=256;		
  end; 
 
  case SetMat of
    0: SetMat:=0;
    1: SetMat:=1;
    2: SetMat:=2;
    3: SetMat:=3;		
  end;
 
end;

// inizio del programma
begin

 if MessageBox(0,'Settare lo schermo intero?  ', 'Video!',MB_YESNO OR MB_ICONQUESTION) = IDNO 
 then fullscreen := false else fullscreen := true;
  
 OGLWindowSetting(ARROW,'',GENERIC,'');
 CreateOGLWindow('Uso di texture come materiale - A,S/left,right=qualit materiale  L=muovi luce on/off  M=normale/texture  barra=swtch materiale', 800, 600, 32, fullscreen);// si possono usare anche dei rapporti diversi da 4/3 e 16/9
 OpenGL_Init(100,0,0,0,0);			  // inizializza la grafica OpenGL(consente d'impostare il colore di sfondo e la profondit della visuale) 
 SetglRefractive();                         // imposta la rifrazione ambientale ed elimina le facce interne
 SetglLight(GL_LIGHT0,0.0,0.0,0.0,0.1);     // imposta la luce ambientale
 OpenGL_CreateList();                       // carica le liste degli oggetti (modelli composti)

 // impostare qui i valori delle variabili   

 REPEAT				     // inizio del ciclo principale

 glCLEAR(GL_COLOR_BUFFER_BIT);
 Setglmsg();

 OpenGL_Draw();             // carica gli elementi che devono essere un aggiornati sullo schermo 
 SwapBuffers(dcWindow);	    // abilita la visualizzazione grafica OpenGL

 // inserire qui eventuali dati aggiuntivi

UNTIL active = false;		// fine del ciclo principale (premere ESC per uscire)

 DeleteOGLWindow();		    // chiude la finestra
end.
